<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [promizr](./promizr.md) &gt; [applyEachSeries](./promizr.applyeachseries.md)

## applyEachSeries() function

The same as [applyEach()](./promizr.applyeach.md)<!-- -->, only `tasks` are applied in series. The next `task` is only called once the current one has completed. This means the `task` functions will complete in order.

<b>Signature:</b>

```typescript
export default function applyEachSeries<T extends AsyncFunction[]>(tasks: T): (...args: Parameters<T[number]>) => Async<Array<ReturnType<T[number]>>>;
```

## Parameters

|  Parameter | Type | Description |
|  --- | --- | --- |
|  tasks | T | Functions to run |

<b>Returns:</b>

(...args: Parameters&lt;T\[number\]&gt;) =&gt; [Async](./promizr.async.md)<!-- -->&lt;Array&lt;ReturnType&lt;T\[number\]&gt;&gt;&gt;

## Example


```typescript
const upper = (value: string) => value.toUpperCase();
const lower = (value: string) => value.toLowerCase();
const prefix = (value: string) => `prefix-${value}`;

const task = promizr.applyEachSeries(action);

const res = await task("Value");
// res === ["VALUE", "value", "prefix-Value"]

```

