<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [promizr](./promizr.md) &gt; [ProgressPromise](./promizr.progresspromise.md)

## ProgressPromise class

A ProgressPromise is a special Promise which allows to track progress of the inner process.

<b>Signature:</b>

```typescript
export default class ProgressPromise<T, P> implements PromiseLike<T> 
```
<b>Implements:</b> PromiseLike&lt;T&gt;

## Constructors

|  Constructor | Modifiers | Description |
|  --- | --- | --- |
|  [(constructor)(executor)](./promizr.progresspromise._constructor_.md) |  | Constructs a new instance of the <code>ProgressPromise</code> class |

## Properties

|  Property | Modifiers | Type | Description |
|  --- | --- | --- | --- |
|  [\_innerPromise](./promizr.progresspromise._innerpromise.md) |  | Promise&lt;T&gt; |  |
|  [\_progress](./promizr.progresspromise._progress.md) |  | P \| undefined |  |
|  [\_progressesCallbacks](./promizr.progresspromise._progressescallbacks.md) |  | Array&lt;(progress: P) =&gt; void&gt; \| undefined |  |

## Methods

|  Method | Modifiers | Description |
|  --- | --- | --- |
|  [all(values)](./promizr.progresspromise.all.md) | <code>static</code> | Creates a <code>ProgressPromise</code> that is resolved with an array of results when all of the provided Promises resolve, or rejected when any Promise is rejected.<!-- -->The <code>progress</code> function returns an array of all progresses from found ProgressPromises in <code>values</code>. |
|  [catch(onrejected)](./promizr.progresspromise.catch.md) |  | Attaches a callback for only the rejection of the Promise. |
|  [defer()](./promizr.progresspromise.defer.md) | <code>static</code> | Returns a new ProgressPromiseDeferred object. |
|  [finally(onfinally)](./promizr.progresspromise.finally.md) |  | Attaches a callback that is invoked when the <code>Promise</code> is settled (fulfilled or rejected). The resolved value cannot be modified from the callback. |
|  [progress(onprogress)](./promizr.progresspromise.progress.md) |  | Adds a progress callback who listen to progress evolution of the <code>ProgressPromise</code>. |
|  [race(promises)](./promizr.progresspromise.race.md) | <code>static</code> | Creates a Promise that is resolved or rejected when any of the provided Promises are resolved or rejected. The <code>progress</code> function returns an array of all progresses from found ProgressPromises in <code>values</code>. |
|  [then(onfulfilled, onrejected)](./promizr.progresspromise.then.md) |  | Attaches callbacks for the resolution and/or rejection of the Promise. |

